diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.c libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.c
--- libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.c	2009-04-19 18:38:14.000000000 +0200
@@ -87,8 +87,8 @@
 
 struct _GnomeDbDataCellRendererComboPrivate
 {
-	GdaSet       *paramlist;
-	GdaSetSource *source;
+	GnomeDbSet       *paramlist;
+	GnomeDbSetSource *source;
 	guint         focus_out_id;
 	guint         attributes;
 	gboolean      to_be_deleted;
@@ -299,7 +299,7 @@
 					/* if (gnome_db_data_model_get_status (datacell->priv->data_model) &  */
 /* 					    GNOME_DB_DATA_MODEL_NEEDS_INIT_REFRESH) */
 /* 						gnome_db_data_model_refresh (datacell->priv->data_model, NULL); */
-					row = gda_data_model_get_row_from_values (datacell->priv->source->data_model,
+					row = gda_data_model_get_row_from_values (datacell->priv->source->source->data_model,
 										  values,
 										  datacell->priv->source->ref_cols_index);
 					if (row >= 0) {
@@ -310,7 +310,7 @@
 						for (i = 0; i < datacell->priv->source->shown_n_cols; i++) {
 							const GValue *value;
 							
-							value = gda_data_model_get_value_at (datacell->priv->source->data_model,
+							value = gda_data_model_get_value_at (datacell->priv->source->source->data_model,
 											     datacell->priv->source->shown_cols_index [i],
 											     row, NULL);
 							dsplay_values = g_list_append (dsplay_values, (GValue *) value);
@@ -369,14 +369,14 @@
 		if (datacell->priv->paramlist)
 			g_object_unref (datacell->priv->paramlist);
 
-		datacell->priv->paramlist = GDA_SET(g_value_get_object(value));
+		datacell->priv->paramlist = GNOME_DB_SET (g_value_get_object(value));
 		if(datacell->priv->paramlist)
 			g_object_ref(datacell->priv->paramlist);
 
 		g_object_ref (G_OBJECT (datacell->priv->paramlist)); 
 		break;
 	case PROP_PARAMLISTSOURCE:
-		datacell->priv->source = GDA_SET_SOURCE(g_value_get_pointer(value));
+		datacell->priv->source = GNOME_DB_SET_SOURCE (g_value_get_pointer(value));
 		break;
 	default:
 		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
@@ -426,7 +426,7 @@
 /**
  * gnome_db_data_cell_renderer_combo_new
  * @paramlist: a #GdaSet object
- * @source: a #GdaSetSource structure listed in @paramlist->sources_list
+ * @source: a #GnomeDbSetSource structure listed in @paramlist->sources_list
  * 
  * Creates a new #GnomeDbDataCellRendererCombo which will fill the parameters listed in
  * @source->nodes with values available from @source->data_model.
@@ -434,7 +434,7 @@
  * Return value: the new cell renderer
  **/
 GtkCellRenderer *
-gnome_db_data_cell_renderer_combo_new (GdaSet *paramlist, GdaSetSource *source)
+gnome_db_data_cell_renderer_combo_new (GnomeDbSet *paramlist, GnomeDbSetSource *source)
 {
 	GObject *obj;
 
@@ -557,7 +557,7 @@
 	if (cell_text->editable == FALSE)
 		return NULL;
 
-	combo = gnome_db_combo_new_with_model (GDA_DATA_MODEL (datacell->priv->source->data_model),
+	combo = gnome_db_combo_new_with_model (GDA_DATA_MODEL (datacell->priv->source->source->data_model),
 					       datacell->priv->source->shown_n_cols, 
 					       datacell->priv->source->shown_cols_index);
 	
diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.h libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.h
--- libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.h	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-combo.h	2009-04-19 18:38:14.000000000 +0200
@@ -25,6 +25,7 @@
 #include <gtk/gtk.h>
 #include <pango/pango.h>
 #include <libgnomedb/gnome-db-decl.h>
+#include <libgnomedb/gnome-db-set.h>
 
 #ifdef __cplusplus
 extern "C" {
@@ -59,7 +60,7 @@
 };
 
 GType            gnome_db_data_cell_renderer_combo_get_type (void) G_GNUC_CONST;
-GtkCellRenderer *gnome_db_data_cell_renderer_combo_new      (GdaSet *paramlist, GdaSetSource *source);
+GtkCellRenderer *gnome_db_data_cell_renderer_combo_new      (GnomeDbSet *paramlist, GnomeDbSetSource *source);
 
 #ifdef __cplusplus
 }
diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.c libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.c
--- libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.c	2009-04-19 18:38:14.000000000 +0200
@@ -74,16 +74,16 @@
 	PROP_VALUE_ATTRIBUTES,
 	PROP_EDITABLE,
 	PROP_TO_BE_DELETED,
-  PROP_STORE,
-  PROP_ITER,
-  PROP_GROUP
+	PROP_STORE,
+	PROP_ITER,
+	PROP_GROUP
 };
 
 struct _GnomeDbDataCellRendererInfoPriv {
 	/* attributes valid for the while life of the object */
 	GnomeDbDataStore      *store;
 	GdaDataModelIter      *iter;
-	GdaSetGroup *group;
+	GnomeDbSetGroup       *group;
 
 	/* attribute valid only for drawing */
 	gboolean               active;
@@ -287,7 +287,7 @@
 		g_object_ref (G_OBJECT (cellinfo->priv->iter));
     		break;
 	case PROP_GROUP:
-		cellinfo->priv->group = GDA_SET_GROUP(g_value_get_pointer(value));
+		cellinfo->priv->group = GNOME_DB_SET_GROUP (g_value_get_pointer(value));
    		break;
 	default:
 		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
@@ -313,16 +313,16 @@
  **/
 GtkCellRenderer *
 gnome_db_data_cell_renderer_info_new (GnomeDbDataStore *store, 
-				      GdaDataModelIter *iter, GdaSetGroup *group)
+				      GdaDataModelIter *iter, GnomeDbSetGroup *group)
 {
 	GObject *obj;
 
 	g_return_val_if_fail (GNOME_DB_IS_DATA_STORE (store), NULL);
 	g_return_val_if_fail (GDA_IS_SET (iter), NULL);
-	g_return_val_if_fail (group && g_slist_find (((GdaSet *) iter)->groups_list, group), NULL);
+	g_return_val_if_fail (group, NULL);
 
 	obj = g_object_new (GNOME_DB_TYPE_DATA_CELL_RENDERER_INFO, 
-                      "store", store, "iter", iter, "group", group, NULL);
+			    "store", store, "iter", iter, "group", group, NULL);
 
 	return (GtkCellRenderer *) obj;
 }
@@ -469,7 +469,7 @@
 		gtk_tree_path_free (treepath);
 
 		/* we want the attributes */
-		if (! cellinfo->priv->group->nodes_source) {
+		if (! cellinfo->priv->group->group->nodes_source) {
 			gint col;
 			GdaDataModel *proxied_model;
 			GdaDataProxy *proxy;
@@ -477,9 +477,9 @@
 			proxy = gnome_db_data_store_get_proxy (cellinfo->priv->store);
 			proxied_model = gda_data_proxy_get_proxied_model (proxy);
 
-			g_assert (g_slist_length (cellinfo->priv->group->nodes) == 1);
+			g_assert (g_slist_length (cellinfo->priv->group->group->nodes) == 1);
 			col = g_slist_index (GDA_SET (cellinfo->priv->iter)->holders,
-					     GDA_SET_NODE (cellinfo->priv->group->nodes->data)->holder);
+					     GDA_SET_NODE (cellinfo->priv->group->group->nodes->data)->holder);
 
 			gtk_tree_model_get (GTK_TREE_MODEL (cellinfo->priv->store), &iter, 
 					    gda_data_model_get_n_columns (proxied_model) + col, 
@@ -487,9 +487,9 @@
 		}
 		else 
 			attributes = gnome_db_utility_proxy_compute_attributes_for_group (cellinfo->priv->group, 
-										 cellinfo->priv->store,
-										 cellinfo->priv->iter,
-										 &iter, NULL);
+											  cellinfo->priv->store,
+											  cellinfo->priv->iter,
+											  &iter, NULL);
 		
 		/* build the popup menu */
 		menu = gnome_db_utility_entry_build_actions_menu (G_OBJECT (cellinfo), attributes, 
diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.h libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.h
--- libgnomedb/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.h	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-data-cell-renderer-info.h	2009-04-19 18:38:14.000000000 +0200
@@ -26,6 +26,7 @@
 #include <libgnomedb/gnome-db-decl.h>
 #include <libgda/gda-enums.h>
 #include <libgda/gda-decl.h>
+#include <libgnomedb/gnome-db-set.h>
 
 G_BEGIN_DECLS
 
@@ -60,7 +61,7 @@
 GType            gnome_db_data_cell_renderer_info_get_type  (void) G_GNUC_CONST;
 GtkCellRenderer *gnome_db_data_cell_renderer_info_new       (GnomeDbDataStore *store,
 							     GdaDataModelIter *iter, 
-							     GdaSetGroup *group);
+							     GnomeDbSetGroup *group);
 G_END_DECLS
 
 #endif /* __GNOME_DB_DATA_CELL_RENDERER_INFO_H__ */
diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-entry-combo.c libgnomedbnew/libgnomedb/data-entries/gnome-db-entry-combo.c
--- libgnomedb/libgnomedb/data-entries/gnome-db-entry-combo.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-entry-combo.c	2009-04-19 18:38:14.000000000 +0200
@@ -55,6 +55,9 @@
 static gboolean        gnome_db_entry_combo_expand_in_layout  (GnomeDbDataEntry *de);
 static void            gnome_db_entry_combo_grab_focus        (GnomeDbDataEntry *de);
 
+static void           _gnome_db_entry_combo_construct(GnomeDbEntryCombo* combo, 
+						      GnomeDbSet *paramlist, GnomeDbSetSource *source);
+
 /* properties */
 enum
 {
@@ -78,8 +81,8 @@
         GtkWidget              *combo_entry;
 	GSList                 *combo_nodes; /* list of ComboNode structures */
 
-	GdaSet       *paramlist;
-	GdaSetSource *source;	
+	GnomeDbSet             *paramlist; // useless?
+	GnomeDbSetSource       *source;	
 	
 	gboolean                data_valid;
 	gboolean                null_forced;
@@ -213,8 +216,8 @@
 
 /**
  * gnome_db_entry_combo_new
- * @paramlist: a #GdaSet object
- * @source: a #GdaSetSource structure, part of @paramlist
+ * @paramlist: a #GnomeDbSet object
+ * @source: a #GnomeDbSetSource structure, part of @paramlist
  *
  * Creates a new #GnomeDbEntryCombo widget. The widget is a combo box which displays a
  * selectable list of items (the items come from the 'source->data_model' data model)
@@ -225,7 +228,7 @@
  * Returns: the new widget
  */
 GtkWidget *
-gnome_db_entry_combo_new (GdaSet *paramlist, GdaSetSource *source)
+gnome_db_entry_combo_new (GnomeDbSet *paramlist, GnomeDbSetSource *source)
 {
 	GObject *obj;
 
@@ -246,7 +249,7 @@
  * TODO: This is just a work-around for language bindings. Ideally we would use construction
  * properties instead.
  */
-void _gnome_db_entry_combo_construct (GnomeDbEntryCombo* combo, GdaSet *paramlist, GdaSetSource *source)
+void _gnome_db_entry_combo_construct (GnomeDbEntryCombo* combo, GnomeDbSet *paramlist, GnomeDbSetSource *source)
 {
 	GSList *list;
 	GSList *values;
@@ -265,7 +268,7 @@
 	 * and use the values provided by the parameters to display the correct row */
 	null_possible = TRUE;
 	values = NULL;
-	list = source->nodes;
+	list = source->source->nodes;
 	while (list) {
 		ComboNode *cnode = g_new0 (ComboNode, 1);
 		
@@ -282,7 +285,7 @@
 	combo->priv->null_possible = null_possible;
 
 	/* create the combo box itself */
-	entry = gnome_db_combo_new_with_model (GDA_DATA_MODEL (source->data_model), 
+	entry = gnome_db_combo_new_with_model (GDA_DATA_MODEL (source->source->data_model), 
 					       combo->priv->source->shown_n_cols, 
 					       combo->priv->source->shown_cols_index);
 	g_signal_connect (G_OBJECT (entry), "changed",
@@ -616,7 +619,7 @@
 			GdaColumn *attrs;
 			GType type=GDA_TYPE_NULL;
 			
-			attrs = gda_data_model_describe_column (combo->priv->source->data_model, 
+			attrs = gda_data_model_describe_column (combo->priv->source->source->data_model, 
 								COMBO_NODE (nodes->data)->node->source_column);
 			arg_value = (GValue*) (argptr->data);
 			
diff -urN libgnomedb/libgnomedb/data-entries/gnome-db-entry-combo.h libgnomedbnew/libgnomedb/data-entries/gnome-db-entry-combo.h
--- libgnomedb/libgnomedb/data-entries/gnome-db-entry-combo.h	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/data-entries/gnome-db-entry-combo.h	2009-04-19 18:38:14.000000000 +0200
@@ -24,6 +24,7 @@
 #include <gtk/gtk.h>
 #include "gnome-db-entry-shell.h"
 #include <libgnomedb/gnome-db-data-entry.h>
+#include <libgnomedb/gnome-db-set.h>
 
 G_BEGIN_DECLS
 
@@ -53,7 +54,7 @@
 
 
 GType           gnome_db_entry_combo_get_type          (void) G_GNUC_CONST;
-GtkWidget      *gnome_db_entry_combo_new               (GdaSet *paramlist, GdaSetSource *source);
+GtkWidget      *gnome_db_entry_combo_new               (GnomeDbSet *paramlist, GnomeDbSetSource *source);
 
 gboolean        gnome_db_entry_combo_set_values        (GnomeDbEntryCombo *combo, GSList *values);
 GSList         *gnome_db_entry_combo_get_values        (GnomeDbEntryCombo *combo);
@@ -62,9 +63,6 @@
 GSList         *gnome_db_entry_combo_get_values_orig   (GnomeDbEntryCombo *combo);
 void            gnome_db_entry_combo_set_values_default(GnomeDbEntryCombo *combo, GSList *values);
 
-void _gnome_db_entry_combo_construct(GnomeDbEntryCombo* combo, 
-                                     GdaSet *paramlist, GdaSetSource *source);
-
 G_END_DECLS
 
 #endif


diff -urN libgnomedb/libgnomedb/data_layout.dtd libgnomedbnew/libgnomedb/data_layout.dtd
--- libgnomedb/libgnomedb/data_layout.dtd	1970-01-01 01:00:00.000000000 +0100
+++ libgnomedbnew/libgnomedb/data_layout.dtd	2009-04-19 18:38:14.000000000 +0200
@@ -0,0 +1,194 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<!--
+DTD for data layout.
+TODO: Make sure that all the comments list all the attributes and their meaning.
+-->
+
+<!-- data layouts determine the order of items and sorting of the fields. There are many
+     different ways that they are grouped with the various data_layout* possibilities, but the idea is
+     the same. They all have a sequence, which tells when they are displayed. In addition, there is a column_count
+     on the grouping subnodes, which is the number of columns wide the element should be. 
+     The name of the data_layout will be either "list" or "details".-->
+
+<!ELEMENT data_layouts (data_layout_details | data_layout_list | data_layout)* >
+
+<!ELEMENT data_layout (data_layout_groups)>
+<!ATTLIST data_layout
+          name CDATA #REQUIRED
+          parent_table CDATA #IMPLIED >
+
+<!ELEMENT data_layout_groups (data_layout_group)*>
+<!ATTLIST data_layout_groups>
+
+<!-- a data_layout_group is just a the setup of fields to be shown. It encapsulates everything else. -->
+
+<!ELEMENT data_layout_group (trans_set | data_layout_group | data_layout_item | data_layout_portal |
+          data_layout_item_groupby | data_layout_button | data_layout_notebook | data_layout_item_header | 
+          trans_set | data_layout_text)* >
+<!ATTLIST data_layout_group
+          name CDATA #REQUIRED
+          title CDATA #IMPLIED
+          sequence CDATA #IMPLIED
+          columns_count CDATA #REQUIRED >
+
+<!-- a data_layout_notebook is the tabbed display of tables in the interface. -->
+
+<!ELEMENT data_layout_notebook (data_layout_group|data_layout_portal)*>
+<!ATTLIST data_layout_notebook
+          name CDATA #REQUIRED
+          columns_count CDATA #REQUIRED
+          sequence CDATA #IMPLIED
+          title CDATA #IMPLIED >
+
+<!-- a data_layout_item_groupby is a data_layout_group that sorts -->
+
+<!ELEMENT data_layout_item_groupby (trans_set | groupby | sortby | data_layout_group | data_layout_item |
+          data_layout_portal | data_layout_button | data_layout_item_groupby | secondary_fields | 
+          data_layout_item_summary | data_layout_item_verticalgroup)* >
+<!ATTLIST data_layout_item_groupby
+          name CDATA #REQUIRED
+          title CDATA #IMPLIED
+          sequence CDATA #IMPLIED
+          columns_count CDATA #REQUIRED
+          border_width CDATA #IMPLIED >
+
+<!-- data_layout_text and text are for displaying text. -->
+
+<!ELEMENT data_layout_text (text)*>
+<!ATTLIST data_layout_text
+          sequence CDATA #REQUIRED >
+
+<!ELEMENT text EMPTY>
+<!ATTLIST text
+          title CDATA #REQUIRED >
+
+<!-- sortby describes what a data_layout_item_groupby sorts by. -->
+
+<!ELEMENT sortby (data_layout_item)*>
+<!ATTLIST sortby>
+
+<!-- data_layout_item_verticalgroup is used to display a vertical group of fields. -->
+
+<!ELEMENT data_layout_item_verticalgroup (data_layout_item)*>
+<!ATTLIST data_layout_item_verticalgroup
+          name CDATA #REQUIRED
+          columns_count CDATA #REQUIRED
+          sequence CDATA #REQUIRED >
+
+<!-- data_layout_item_summary and data_layout_item_fieldsummary summarize other
+     fields. -->
+
+<!ELEMENT data_layout_item_summary (data_layout_item_fieldsummary)*>
+<!ATTLIST data_layout_item_summary
+          name CDATA #REQUIRED
+          columns_count CDATA #REQUIRED
+          sequence CDATA #IMPLIED >
+
+<!ELEMENT data_layout_item_fieldsummary (formatting)>
+<!ATTLIST data_layout_item_fieldsummary
+          name CDATA #REQUIRED
+          editable (true|false) "false"
+          use_default_formatting (true|false) "true"
+          sequence CDATA #IMPLIED
+          summarytype CDATA #REQUIRED >
+
+<!-- groupby is used to determine how data_layout_item_groupby items group. -->
+
+<!ELEMENT groupby (formatting|title_custom)*>
+<!ATTLIST groupby
+          name CDATA #REQUIRED
+          editable (true|false) "false"
+          use_default_formatting (true|false) "true"
+          relationship CDATA #IMPLIED >
+
+<!-- secondary fields are fields derived from other fields, this is a list of them. -->
+
+<!ELEMENT secondary_fields (data_layout_group)>
+<!ATTLIST secondary_fields>
+
+
+<!-- trans_set and trans are used for translating. They describe a set of alternatives
+     for different languages. -->
+
+<!ELEMENT trans_set (trans*)>
+<!ATTLIST trans_set>
+
+<!ELEMENT trans EMPTY>
+<!ATTLIST trans
+          loc CDATA #REQUIRED
+          val CDATA #REQUIRED >
+
+<!-- A data_layout_item is a single entry in the display formatting, which tells how a single
+     field is displayed. -->
+
+<!ELEMENT data_layout_item (formatting|title_custom)* >
+<!ATTLIST data_layout_item
+          name CDATA #REQUIRED
+          relationship CDATA #IMPLIED
+          group CDATA #IMPLIED
+          sequence CDATA #IMPLIED
+          editable CDATA #IMPLIED
+          use_default_formatting (true|false) "true"
+          related_relationship CDATA #IMPLIED
+          sort_ascending (true|false) "false" >
+
+<!-- a data_layout_item_header is the items that go at the very top of the database (e.g. the
+     organization name and logo). -->
+
+<!ELEMENT data_layout_item_header (data_layout_item)*>
+<!ATTLIST data_layout_item_header
+          name CDATA #REQUIRED
+          columns_count CDATA #REQUIRED
+          sequence CDATA #REQUIRED >
+
+<!-- data_layout_button is a way to have a custom script (python) control the
+     display and effect of a button in the database. -->
+
+<!ELEMENT data_layout_button (script?)>
+<!ATTLIST data_layout_button
+          title CDATA #REQUIRED
+          sequence CDATA #IMPLIED
+          script CDATA #IMPLIED >
+
+<!-- a script node is used to embed python code into the custom button. -->
+
+<!ELEMENT script ANY>
+<!ATTLIST script>
+
+<!-- a title_custom is used to give a different name next to a field than normal. -->
+
+<!ELEMENT title_custom ANY>
+<!ATTLIST title_custom
+          title CDATA #IMPLIED
+          use_custom (true|false) "true" >
+
+<!-- a data_layout_portal is the essential information, a short and quick list of values
+     that are probably of interest to others (e.g. contact information, name, etc). -->
+
+<!ELEMENT data_layout_portal ANY >
+<!ATTLIST data_layout_portal
+          name CDATA #REQUIRED
+          relationship CDATA #REQUIRED
+          sequence CDATA #REQUIRED
+          hide CDATA #IMPLIED
+          columns_count CDATA #IMPLIED >
+
+<!-- reports and data reports make short sheets of important information that
+     distill a larger database. data_report(s) is the old interface; use reports if you are
+     writing a new XML document. -->
+
+<!ELEMENT data_reports (data_report)* >
+
+<!ELEMENT data_report (data_layout_groups)>
+<!ATTLIST data_report
+          name CDATA #REQUIRED
+          title CDATA #REQUIRED >
+
+<!ELEMENT reports (report)*>
+<!ATTLIST reports>
+
+<!ELEMENT report (data_layout_groups|trans_set)*>
+<!ATTLIST report
+          name CDATA #REQUIRED
+          title CDATA #IMPLIED
+          show_table_title (true|false) "false" >
